/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef GUI_EDITORS_H
#define GUI_EDITORS_H

#include <toolkit/editors.h>

namespace Toolkit {
    class Input;
    class Selector;
}

class StringAttributeItem;
class SpinboxAttributeItem;
class SelectorAttributeItem;

class StringItemEditor : public ItemEditor
{
    StringAttributeItem &item;
    Toolkit::Input *input;
public:
    StringItemEditor(StringAttributeItem &item);
    void paint(Toolkit::Connection &conn, X::GC gc,
	       const Toolkit::Region &region,
	       unsigned long background, X::Pixmap pixmap);
    void createWidget(Toolkit::Connection &conn);
    void deleteWidget();
    void invoke(Time time, int x, int y, int x_root, int y_root);
    void accept();
    void reset();
};

class SpinboxItemEditor : public ItemEditor
{
    SpinboxAttributeItem &item;
    Toolkit::Input *input;
public:
    SpinboxItemEditor(SpinboxAttributeItem &editor);
    void paint(Toolkit::Connection &conn, X::GC gc,
	       const Toolkit::Region &region,
	       unsigned long background, X::Pixmap pixmap);
    void createWidget(Toolkit::Connection &conn);
    void deleteWidget();
    void invoke(Time time, int x, int y, int x_root, int y_root);
    void accept();
    void reset();
};

class SelectorItemEditor : public ItemEditor
{
    SelectorAttributeItem &item;
    Toolkit::Selector *selector;
public:
    SelectorItemEditor(SelectorAttributeItem &editor);
    void paint(Toolkit::Connection &conn, X::GC gc,
	       const Toolkit::Region &region,
	       unsigned long background, X::Pixmap pixmap);
    void createWidget(Toolkit::Connection &conn);
    void deleteWidget();
    void invoke(Time time, int x, int y, int x_root, int y_root);
    void accept();
    void reset();
};

#endif
