/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef GUI_VIEWS_H
#define GUI_VIEWS_H

#include <toolkit/toolkit.h>

class Hub;
class Item3;

class ProjectDirView : public Toolkit::DirectoryView
{
    Hub &hub;
    mutable std::map<Item3 *, Toolkit::ViewShadow *> recent;
    void setSelected(Toolkit::ViewShadow *selected, bool toggle);
    bool isSelected(Toolkit::ViewShadow *shadow) const;
public:
    ProjectDirView(Toolkit::Connection &conn, Hub &hub);
    Toolkit::ViewShadow *selected() const;
};

class LibraryView : public Toolkit::DirectoryView
{
    Hub &hub;
    Toolkit::ViewShadow *_selected;
    Toolkit::Menu *const menu;
    void setSelected(Toolkit::ViewShadow *selected, bool toggle);
    bool isSelected(Toolkit::ViewShadow *shadow) const;
public:
    LibraryView(Toolkit::Connection &conn, Hub &hub, Toolkit::Menu *menu);
    Toolkit::ViewShadow *selected() const;
    void highlightedShadowChanged();
    void buttonPressEvent(Time time, int x, int y, int x_root, int y_root,
			  unsigned int state, unsigned int button);
};

class HistoryView1 : public Toolkit::HistoryView
{
    Hub &hub;
    void setSelected(Toolkit::HistoryViewShadow *selected);
    bool isSelected(Toolkit::HistoryViewShadow *shadow) const;
public:
    HistoryView1(Toolkit::Connection &conn, Hub &hub);
    Toolkit::HistoryViewShadow *selected() const;
};

class ObjectsView : public Toolkit::DirectoryView
{
    Hub &hub;
    void setSelected(Toolkit::ViewShadow *selected, bool toggle);
    bool isSelected(Toolkit::ViewShadow *shadow) const;
public:
    ObjectsView(Toolkit::Connection &conn, Hub &hub);
};

class ToolboxView : public Toolkit::ButtonView
{
    Hub &hub;
    void setSelected(Toolkit::ViewShadow *selected);
    bool isSelected(Toolkit::ViewShadow *shadow) const;
public:
    ToolboxView(Toolkit::Connection &conn, Hub &hub);
    Toolkit::ViewShadow *selected() const;
};

class MyPropertiesView : public Toolkit::PropertiesView
{
    Toolkit::Menu *const menu;
public:
    MyPropertiesView(Toolkit::Connection &conn, Toolkit::Menu *menu);
    void buttonPressEvent(Time time, int x, int y,
			  int x_root, int y_root,
			  unsigned int state, unsigned int button);
};

#endif
