/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef NB_ATTRIBUTE_H
#define NB_ATTRIBUTE_H

#include "attribute.h"

class StandardInterior;

class CoinValueAttributeItem : public SelectorAttributeItem
{
public:
    CoinValueAttributeItem(Hub &hub, Attribute &attribute);
    Item *selectedItem();
    void setSelectedItem(Item *value);
};

namespace NeverballAttributes {
    extern Attribute symbol, travelTime, path, enableFlag, model, value,
		     radius, timer, state, detail;
    extern StandardInterior coinValueEnum;
}

class NeverballAttributeItems
{
public:
    NeverballAttributeItems(Hub &hub);
    StringAttributeItem symbol;
    DoubleAttributeItem travelTime;
    /*Path*/AttributeItem path;
    BoolAttributeItem enableFlag;
    StringAttributeItem model;
    CoinValueAttributeItem value;
    MetrumAttributeItem radius;
    DoubleAttributeItem timer;
    IntegerAttributeItem state;
    BoolAttributeItem detail;
};

#endif
