/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef NB_MAJORMODE_H
#define NB_MAJORMODE_H

#include "majormode.h"

class PathObject;

class PathMajorMode : public MajorMode
{
public:
    PathMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode startMinorMode;
    PointSelectMinorMode connectMinorMode;

    PathObject *path;
/** QCheckBox *checkBox; **/
};

class BodyMajorMode : public MajorMode
{
public:
    BodyMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode minorMode;
};

class CoinMajorMode : public MajorMode
{
public:
    CoinMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode minorMode;

/** QCheckBox *checkBox; **/
};

class GoalMajorMode : public MajorMode
{
public:
    GoalMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode centerMinorMode;
    PointSelectMinorMode perimeterMinorMode;

/** QComboBox *comboBox; **/
};

class JumpMajorMode : public MajorMode
{
public:
    JumpMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode posMinorMode;
    PointSelectMinorMode radiusMinorMode;
    PointSelectMinorMode targetMinorMode;

/** QComboBox *comboBox; **/
};

class SwitchMajorMode : public MajorMode
{
public:
    SwitchMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode posMinorMode;
    PointSelectMinorMode radiusMinorMode;
    PointSelectMinorMode connectMinorMode;

/** QComboBox *comboBox; **/
};

class BillboardMajorMode : public MajorMode
{
public:
    BillboardMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode posMinorMode;
};

class UserMajorMode : public MajorMode
{
public:
    UserMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode posMinorMode;
    PointSelectMinorMode radiusMinorMode;

/** QCheckBox *radiusCheckBox;
    QCheckBox *offsetCheckBox; **/
};

class ViewMajorMode : public MajorMode
{
public:
    ViewMajorMode(Hub &hub);
    void paint(Painter &painter);
    List<ActionLine *> lines(ActionPoint *handle);

    void accept(MinorMode *minor_mode);
    void cancel();

private:
    PointSelectMinorMode posMinorMode;
    PointSelectMinorMode targetMinorMode;
};

#endif
