/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef SCH_PICTURE_H
#define SCH_PICTURE_H

#include "gen_rectangular.h"

class PictureMajorMode : public RectangularMajorMode
{
public:
    PictureMajorMode(Hub &hub);
private:
    Object *buildObject(const Metrum3 &p0, const Metrum3 &p1);
};

class PictureObject : public RectangularObject
{
public:
    PictureObject(const Metrum3 &p0, const Metrum3 &p1, Drawing *drawing);
    String name() const;
    Icon *icon() const;
    void paint(Painter &painter, const Embedding &embedding);
    void write(XMLWriter *writer);

    List<Attribute *> attributes() const;
    Variant attribute(const Attribute *attribute) const;
    Variant attributeDefault(const Attribute *attribute) const;
    void setAttribute(const Variant &value, const Attribute *attribute);

    int angle;
    bool mirrored;
    bool embedded;
    String filename;
    String data;
};

#endif
