/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include <math.h>
#include "util/screen.h"


void ScreenPos::computeParameters(
    const ScreenPos &base, const ScreenPos &tangent,
    ScreenDist &parameter, ScreenDist &distance) const
{
    ScreenPos t = tangent / sqrt(tangent.x() * tangent.x() +
				 tangent.y() * tangent.y());
    ScreenPos rel_base = operator-(base);

    parameter = rel_base.x() * t.x() + rel_base.y() * t.y();
    distance = rel_base.x() * t.y() - rel_base.y() * t.x();
    if (distance < 0)
	distance = -distance;
}

ScreenDist ScreenPos::length() const
{
    return sqrt(xp * xp + yp * yp);
}
