/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef ATTMODEL_H
#define ATTMODEL_H

#include "editors.h"

class EnumModel
{
    StandardItem solid_item, dotted_item, dashed_item,
		 center_item, phantom_item;
    std::vector<Item *> items();
public:
    EnumModel();
    StandardInterior interior;
};

class AttributeModel
{
    StandardItem geometry_item, center_item, x_item, y_item, radius_item,
		 attributes_item, color_item, line_item, line_width_item,
		 line_cap_style_item, line_dash_style_item,
		 line_dash_length_item, line_dash_spacing_item, fill_item,
		 fill_type_item, fill_width_item, fill_angle0_item,
		 fill_pitch0_item, fill_angle1_item, fill_pitch1_item;
    InputEditor center_editor, x_editor, y_editor, radius_editor,
		line_width_editor, line_dash_length_editor,
		line_dash_spacing_editor, fill_width_editor,
		fill_angle0_editor, fill_pitch0_editor,
		fill_angle1_editor, fill_pitch1_editor;
    EnumModel color_model, line_cap_style_model,
	      line_dash_style_model, fill_type_model;
    SelectorEditor color_editor, line_cap_style_editor,
		   line_dash_style_editor, fill_type_editor;
    std::vector<Item *> items();
public:
    AttributeModel();
    StandardInterior interior;
};

#endif
