/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_DOCKS_CONFIGURATION_H
#define TOOLKIT_DOCKS_CONFIGURATION_H

#include "../docks.h"

class Toolkit::Docks::Configuration
{
    std::string const str;
    const char *c;
public:
    Configuration(const std::string &str);
    ~Configuration();

    bool listFirst();
    bool listNext();
    void consumeSpace();
    std::string readNextToken();
    std::string readLastToken();
    bool fullyConsumed() const;

    static double toDouble(const std::string &str);
    static int toInt(const std::string &str);

    class Error : public std::exception
    {
    };
};

#endif
