/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_DOCKS_LAYOUTW_H
#define TOOLKIT_DOCKS_LAYOUTW_H

#include "focus.h"

class Toolkit::Docks::LayoutWidget : public ContainerWidget
{
    class ResizeOperation;

    Logic &logic;
    ColumnWidget *const left, *const right;
    Control left_control, right_control;
    double left_share, right_share;
    int left_width, right_width;
    ResizeOperation *left_resize, *right_resize;
    void updateLayout();
public:
    LayoutWidget(Connection &conn, Logic &logic);
    ~LayoutWidget();
    FocussableControl mainControl;

    void readConfiguration(Configuration &config);
    void writeConfiguration(std::ostringstream &stream) const;
    void resetConfiguration();

    void sizeRequirementsChanged(WidgetControl *control);

    void motionEvent(Time time, int x, int y, int x_root, int y_root,
		     unsigned int state, char is_hint);
    void buttonPressEvent(Time time, int x, int y, int x_root, int y_root,
			  unsigned int state, unsigned int button);
    void buttonReleaseEvent(Time time, int x, int y, int x_root, int y_root,
			    unsigned int state, unsigned int button);
};

#endif
