/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_EDITORS_H
#define TOOLKIT_EDITORS_H

#include "x_abstraction.h"

namespace Toolkit {
    class Widget;
    class Connection;
    class Region;
}

class ItemEditor
{
    Toolkit::Widget *_widget;
public:
    ItemEditor();
    virtual ~ItemEditor();
    Toolkit::Widget *widget() const;

    virtual void paint(Toolkit::Connection &conn, X::GC gc,
		       const Toolkit::Region &region,
		       unsigned long background, X::Pixmap pixmap) = 0;

    virtual void createWidget(Toolkit::Connection &conn) = 0;
    virtual void deleteWidget() = 0;
    virtual void invoke(Time time, int x, int y, int x_root, int y_root) = 0;
    virtual void accept() = 0;
    virtual void reset() = 0;
protected:
    void setWidget(Toolkit::Widget *widget);
};

#endif
