/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_ICON_H
#define TOOLKIT_ICON_H

#include "x_abstraction.h"

namespace Toolkit {
    class IconPixmap; /* internal */
    class IconMask; /* internal */
    class Connection;
}

class Icon
{
    void const *const icon_data;
    std::vector<Toolkit::IconPixmap *> _pixmaps;
    std::vector<Toolkit::IconMask *> _masks;
public:
    Icon(void const *icon_data);
    ~Icon();
    X::Pixmap pixmap(Toolkit::Connection &conn, unsigned long pixel,
		     bool disabled = false);
    X::Pixmap mask(Toolkit::Connection &conn);
    unsigned int width() const;
    unsigned int height() const;
};

#endif
