/* KeySym <-> char* translation (generated from <X11/keysymdef.h>)
   Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include <string.h>
#include "keysym_nonglyph.h"


KeySym lookup_nonglyph_keysym(const char *name)
{
    if (strncmp(name, "Hangul_", 7) == 0) {
	const char *suffix = name + 7;
        if (strcmp(suffix, "Kiyeog") == 0) return 0xea1;
        if (strcmp(suffix, "SsangKiyeog") == 0) return 0xea2;
        if (strcmp(suffix, "KiyeogSios") == 0) return 0xea3;
        if (strcmp(suffix, "Nieun") == 0) return 0xea4;
        if (strcmp(suffix, "NieunJieuj") == 0) return 0xea5;
        if (strcmp(suffix, "NieunHieuh") == 0) return 0xea6;
        if (strcmp(suffix, "Dikeud") == 0) return 0xea7;
        if (strcmp(suffix, "SsangDikeud") == 0) return 0xea8;
        if (strcmp(suffix, "Rieul") == 0) return 0xea9;
        if (strcmp(suffix, "RieulKiyeog") == 0) return 0xeaa;
        if (strcmp(suffix, "RieulMieum") == 0) return 0xeab;
        if (strcmp(suffix, "RieulPieub") == 0) return 0xeac;
        if (strcmp(suffix, "RieulSios") == 0) return 0xead;
        if (strcmp(suffix, "RieulTieut") == 0) return 0xeae;
        if (strcmp(suffix, "RieulPhieuf") == 0) return 0xeaf;
        if (strcmp(suffix, "RieulHieuh") == 0) return 0xeb0;
        if (strcmp(suffix, "Mieum") == 0) return 0xeb1;
        if (strcmp(suffix, "Pieub") == 0) return 0xeb2;
        if (strcmp(suffix, "SsangPieub") == 0) return 0xeb3;
        if (strcmp(suffix, "PieubSios") == 0) return 0xeb4;
        if (strcmp(suffix, "Sios") == 0) return 0xeb5;
        if (strcmp(suffix, "SsangSios") == 0) return 0xeb6;
        if (strcmp(suffix, "Ieung") == 0) return 0xeb7;
        if (strcmp(suffix, "Jieuj") == 0) return 0xeb8;
        if (strcmp(suffix, "SsangJieuj") == 0) return 0xeb9;
        if (strcmp(suffix, "Cieuc") == 0) return 0xeba;
        if (strcmp(suffix, "Khieuq") == 0) return 0xebb;
        if (strcmp(suffix, "Tieut") == 0) return 0xebc;
        if (strcmp(suffix, "Phieuf") == 0) return 0xebd;
        if (strcmp(suffix, "Hieuh") == 0) return 0xebe;
        if (strcmp(suffix, "A") == 0) return 0xebf;
        if (strcmp(suffix, "AE") == 0) return 0xec0;
        if (strcmp(suffix, "YA") == 0) return 0xec1;
        if (strcmp(suffix, "YAE") == 0) return 0xec2;
        if (strcmp(suffix, "EO") == 0) return 0xec3;
        if (strcmp(suffix, "E") == 0) return 0xec4;
        if (strcmp(suffix, "YEO") == 0) return 0xec5;
        if (strcmp(suffix, "YE") == 0) return 0xec6;
        if (strcmp(suffix, "O") == 0) return 0xec7;
        if (strcmp(suffix, "WA") == 0) return 0xec8;
        if (strcmp(suffix, "WAE") == 0) return 0xec9;
        if (strcmp(suffix, "OE") == 0) return 0xeca;
        if (strcmp(suffix, "YO") == 0) return 0xecb;
        if (strcmp(suffix, "U") == 0) return 0xecc;
        if (strcmp(suffix, "WEO") == 0) return 0xecd;
        if (strcmp(suffix, "WE") == 0) return 0xece;
        if (strcmp(suffix, "WI") == 0) return 0xecf;
        if (strcmp(suffix, "YU") == 0) return 0xed0;
        if (strcmp(suffix, "EU") == 0) return 0xed1;
        if (strcmp(suffix, "YI") == 0) return 0xed2;
        if (strcmp(suffix, "I") == 0) return 0xed3;
        if (strcmp(suffix, "J_Kiyeog") == 0) return 0xed4;
        if (strcmp(suffix, "J_SsangKiyeog") == 0) return 0xed5;
        if (strcmp(suffix, "J_KiyeogSios") == 0) return 0xed6;
        if (strcmp(suffix, "J_Nieun") == 0) return 0xed7;
        if (strcmp(suffix, "J_NieunJieuj") == 0) return 0xed8;
        if (strcmp(suffix, "J_NieunHieuh") == 0) return 0xed9;
        if (strcmp(suffix, "J_Dikeud") == 0) return 0xeda;
        if (strcmp(suffix, "J_Rieul") == 0) return 0xedb;
        if (strcmp(suffix, "J_RieulKiyeog") == 0) return 0xedc;
        if (strcmp(suffix, "J_RieulMieum") == 0) return 0xedd;
        if (strcmp(suffix, "J_RieulPieub") == 0) return 0xede;
        if (strcmp(suffix, "J_RieulSios") == 0) return 0xedf;
        if (strcmp(suffix, "J_RieulTieut") == 0) return 0xee0;
        if (strcmp(suffix, "J_RieulPhieuf") == 0) return 0xee1;
        if (strcmp(suffix, "J_RieulHieuh") == 0) return 0xee2;
        if (strcmp(suffix, "J_Mieum") == 0) return 0xee3;
        if (strcmp(suffix, "J_Pieub") == 0) return 0xee4;
        if (strcmp(suffix, "J_PieubSios") == 0) return 0xee5;
        if (strcmp(suffix, "J_Sios") == 0) return 0xee6;
        if (strcmp(suffix, "J_SsangSios") == 0) return 0xee7;
        if (strcmp(suffix, "J_Ieung") == 0) return 0xee8;
        if (strcmp(suffix, "J_Jieuj") == 0) return 0xee9;
        if (strcmp(suffix, "J_Cieuc") == 0) return 0xeea;
        if (strcmp(suffix, "J_Khieuq") == 0) return 0xeeb;
        if (strcmp(suffix, "J_Tieut") == 0) return 0xeec;
        if (strcmp(suffix, "J_Phieuf") == 0) return 0xeed;
        if (strcmp(suffix, "J_Hieuh") == 0) return 0xeee;
        if (strcmp(suffix, "RieulYeorinHieuh") == 0) return 0xeef;
        if (strcmp(suffix, "SunkyeongeumMieum") == 0) return 0xef0;
        if (strcmp(suffix, "SunkyeongeumPieub") == 0) return 0xef1;
        if (strcmp(suffix, "PanSios") == 0) return 0xef2;
        if (strcmp(suffix, "KkogjiDalrinIeung") == 0) return 0xef3;
        if (strcmp(suffix, "SunkyeongeumPhieuf") == 0) return 0xef4;
        if (strcmp(suffix, "YeorinHieuh") == 0) return 0xef5;
        if (strcmp(suffix, "AraeA") == 0) return 0xef6;
        if (strcmp(suffix, "AraeAE") == 0) return 0xef7;
        if (strcmp(suffix, "J_PanSios") == 0) return 0xef8;
        if (strcmp(suffix, "J_KkogjiDalrinIeung") == 0) return 0xef9;
        if (strcmp(suffix, "J_YeorinHieuh") == 0) return 0xefa;
        if (strcmp(suffix, "Start") == 0) return 0xff32;
        if (strcmp(suffix, "End") == 0) return 0xff33;
        if (strcmp(suffix, "Hanja") == 0) return 0xff34;
        if (strcmp(suffix, "Jamo") == 0) return 0xff35;
        if (strcmp(suffix, "Romaja") == 0) return 0xff36;
        if (strcmp(suffix, "Jeonja") == 0) return 0xff38;
        if (strcmp(suffix, "Banja") == 0) return 0xff39;
        if (strcmp(suffix, "PreHanja") == 0) return 0xff3a;
        if (strcmp(suffix, "PostHanja") == 0) return 0xff3b;
        if (strcmp(suffix, "Special") == 0) return 0xff3f;
    }
    if (strncmp(name, "3270_", 5) == 0) {
	const char *suffix = name + 5;
        if (strcmp(suffix, "Duplicate") == 0) return 0xfd01;
        if (strcmp(suffix, "FieldMark") == 0) return 0xfd02;
        if (strcmp(suffix, "Right2") == 0) return 0xfd03;
        if (strcmp(suffix, "Left2") == 0) return 0xfd04;
        if (strcmp(suffix, "BackTab") == 0) return 0xfd05;
        if (strcmp(suffix, "EraseEOF") == 0) return 0xfd06;
        if (strcmp(suffix, "EraseInput") == 0) return 0xfd07;
        if (strcmp(suffix, "Reset") == 0) return 0xfd08;
        if (strcmp(suffix, "Quit") == 0) return 0xfd09;
        if (strcmp(suffix, "PA1") == 0) return 0xfd0a;
        if (strcmp(suffix, "PA2") == 0) return 0xfd0b;
        if (strcmp(suffix, "PA3") == 0) return 0xfd0c;
        if (strcmp(suffix, "Test") == 0) return 0xfd0d;
        if (strcmp(suffix, "Attn") == 0) return 0xfd0e;
        if (strcmp(suffix, "CursorBlink") == 0) return 0xfd0f;
        if (strcmp(suffix, "AltCursor") == 0) return 0xfd10;
        if (strcmp(suffix, "KeyClick") == 0) return 0xfd11;
        if (strcmp(suffix, "Jump") == 0) return 0xfd12;
        if (strcmp(suffix, "Ident") == 0) return 0xfd13;
        if (strcmp(suffix, "Rule") == 0) return 0xfd14;
        if (strcmp(suffix, "Copy") == 0) return 0xfd15;
        if (strcmp(suffix, "Play") == 0) return 0xfd16;
        if (strcmp(suffix, "Setup") == 0) return 0xfd17;
        if (strcmp(suffix, "Record") == 0) return 0xfd18;
        if (strcmp(suffix, "ChangeScreen") == 0) return 0xfd19;
        if (strcmp(suffix, "DeleteWord") == 0) return 0xfd1a;
        if (strcmp(suffix, "ExSelect") == 0) return 0xfd1b;
        if (strcmp(suffix, "CursorSelect") == 0) return 0xfd1c;
        if (strcmp(suffix, "PrintScreen") == 0) return 0xfd1d;
        if (strcmp(suffix, "Enter") == 0) return 0xfd1e;
    }
    if (strncmp(name, "ISO_", 4) == 0) {
	const char *suffix = name + 4;
        if (strcmp(suffix, "Lock") == 0) return 0xfe01;
        if (strcmp(suffix, "Level2_Latch") == 0) return 0xfe02;
        if (strcmp(suffix, "Level3_Shift") == 0) return 0xfe03;
        if (strcmp(suffix, "Level3_Latch") == 0) return 0xfe04;
        if (strcmp(suffix, "Level3_Lock") == 0) return 0xfe05;
        if (strcmp(suffix, "Group_Latch") == 0) return 0xfe06;
        if (strcmp(suffix, "Group_Lock") == 0) return 0xfe07;
        if (strcmp(suffix, "Next_Group") == 0) return 0xfe08;
        if (strcmp(suffix, "Next_Group_Lock") == 0) return 0xfe09;
        if (strcmp(suffix, "Prev_Group") == 0) return 0xfe0a;
        if (strcmp(suffix, "Prev_Group_Lock") == 0) return 0xfe0b;
        if (strcmp(suffix, "First_Group") == 0) return 0xfe0c;
        if (strcmp(suffix, "First_Group_Lock") == 0) return 0xfe0d;
        if (strcmp(suffix, "Last_Group") == 0) return 0xfe0e;
        if (strcmp(suffix, "Last_Group_Lock") == 0) return 0xfe0f;
        if (strcmp(suffix, "Level5_Shift") == 0) return 0xfe11;
        if (strcmp(suffix, "Level5_Latch") == 0) return 0xfe12;
        if (strcmp(suffix, "Level5_Lock") == 0) return 0xfe13;
        if (strcmp(suffix, "Left_Tab") == 0) return 0xfe20;
        if (strcmp(suffix, "Move_Line_Up") == 0) return 0xfe21;
        if (strcmp(suffix, "Move_Line_Down") == 0) return 0xfe22;
        if (strcmp(suffix, "Partial_Line_Up") == 0) return 0xfe23;
        if (strcmp(suffix, "Partial_Line_Down") == 0) return 0xfe24;
        if (strcmp(suffix, "Partial_Space_Left") == 0) return 0xfe25;
        if (strcmp(suffix, "Partial_Space_Right") == 0) return 0xfe26;
        if (strcmp(suffix, "Set_Margin_Left") == 0) return 0xfe27;
        if (strcmp(suffix, "Set_Margin_Right") == 0) return 0xfe28;
        if (strcmp(suffix, "Release_Margin_Left") == 0) return 0xfe29;
        if (strcmp(suffix, "Release_Margin_Right") == 0) return 0xfe2a;
        if (strcmp(suffix, "Release_Both_Margins") == 0) return 0xfe2b;
        if (strcmp(suffix, "Fast_Cursor_Left") == 0) return 0xfe2c;
        if (strcmp(suffix, "Fast_Cursor_Right") == 0) return 0xfe2d;
        if (strcmp(suffix, "Fast_Cursor_Up") == 0) return 0xfe2e;
        if (strcmp(suffix, "Fast_Cursor_Down") == 0) return 0xfe2f;
        if (strcmp(suffix, "Continuous_Underline") == 0) return 0xfe30;
        if (strcmp(suffix, "Discontinuous_Underline") == 0) return 0xfe31;
        if (strcmp(suffix, "Emphasize") == 0) return 0xfe32;
        if (strcmp(suffix, "Center_Object") == 0) return 0xfe33;
        if (strcmp(suffix, "Enter") == 0) return 0xfe34;
    }
    if (strncmp(name, "dead_", 5) == 0) {
	const char *suffix = name + 5;
        if (strcmp(suffix, "grave") == 0) return 0xfe50;
        if (strcmp(suffix, "acute") == 0) return 0xfe51;
        if (strcmp(suffix, "circumflex") == 0) return 0xfe52;
        if (strcmp(suffix, "tilde") == 0) return 0xfe53;
        if (strcmp(suffix, "macron") == 0) return 0xfe54;
        if (strcmp(suffix, "breve") == 0) return 0xfe55;
        if (strcmp(suffix, "abovedot") == 0) return 0xfe56;
        if (strcmp(suffix, "diaeresis") == 0) return 0xfe57;
        if (strcmp(suffix, "abovering") == 0) return 0xfe58;
        if (strcmp(suffix, "doubleacute") == 0) return 0xfe59;
        if (strcmp(suffix, "caron") == 0) return 0xfe5a;
        if (strcmp(suffix, "cedilla") == 0) return 0xfe5b;
        if (strcmp(suffix, "ogonek") == 0) return 0xfe5c;
        if (strcmp(suffix, "iota") == 0) return 0xfe5d;
        if (strcmp(suffix, "voiced_sound") == 0) return 0xfe5e;
        if (strcmp(suffix, "semivoiced_sound") == 0) return 0xfe5f;
        if (strcmp(suffix, "belowdot") == 0) return 0xfe60;
        if (strcmp(suffix, "hook") == 0) return 0xfe61;
        if (strcmp(suffix, "horn") == 0) return 0xfe62;
        if (strcmp(suffix, "stroke") == 0) return 0xfe63;
        if (strcmp(suffix, "abovecomma") == 0) return 0xfe64;
        if (strcmp(suffix, "abovereversedcomma") == 0) return 0xfe65;
        if (strcmp(suffix, "doublegrave") == 0) return 0xfe66;
        if (strcmp(suffix, "belowring") == 0) return 0xfe67;
        if (strcmp(suffix, "belowmacron") == 0) return 0xfe68;
        if (strcmp(suffix, "belowcircumflex") == 0) return 0xfe69;
        if (strcmp(suffix, "belowtilde") == 0) return 0xfe6a;
        if (strcmp(suffix, "belowbreve") == 0) return 0xfe6b;
        if (strcmp(suffix, "belowdiaeresis") == 0) return 0xfe6c;
        if (strcmp(suffix, "invertedbreve") == 0) return 0xfe6d;
        if (strcmp(suffix, "belowcomma") == 0) return 0xfe6e;
        if (strcmp(suffix, "currency") == 0) return 0xfe6f;
        if (strcmp(suffix, "a") == 0) return 0xfe80;
        if (strcmp(suffix, "A") == 0) return 0xfe81;
        if (strcmp(suffix, "e") == 0) return 0xfe82;
        if (strcmp(suffix, "E") == 0) return 0xfe83;
        if (strcmp(suffix, "i") == 0) return 0xfe84;
        if (strcmp(suffix, "I") == 0) return 0xfe85;
        if (strcmp(suffix, "o") == 0) return 0xfe86;
        if (strcmp(suffix, "O") == 0) return 0xfe87;
        if (strcmp(suffix, "u") == 0) return 0xfe88;
        if (strcmp(suffix, "U") == 0) return 0xfe89;
        if (strcmp(suffix, "small_schwa") == 0) return 0xfe8a;
        if (strcmp(suffix, "capital_schwa") == 0) return 0xfe8b;
        if (strcmp(suffix, "greek") == 0) return 0xfe8c;
    }
    if (strncmp(name, "Pointer_", 8) == 0) {
	const char *suffix = name + 8;
        if (strcmp(suffix, "Left") == 0) return 0xfee0;
        if (strcmp(suffix, "Right") == 0) return 0xfee1;
        if (strcmp(suffix, "Up") == 0) return 0xfee2;
        if (strcmp(suffix, "Down") == 0) return 0xfee3;
        if (strcmp(suffix, "UpLeft") == 0) return 0xfee4;
        if (strcmp(suffix, "UpRight") == 0) return 0xfee5;
        if (strcmp(suffix, "DownLeft") == 0) return 0xfee6;
        if (strcmp(suffix, "DownRight") == 0) return 0xfee7;
        if (strcmp(suffix, "Button_Dflt") == 0) return 0xfee8;
        if (strcmp(suffix, "Button1") == 0) return 0xfee9;
        if (strcmp(suffix, "Button2") == 0) return 0xfeea;
        if (strcmp(suffix, "Button3") == 0) return 0xfeeb;
        if (strcmp(suffix, "Button4") == 0) return 0xfeec;
        if (strcmp(suffix, "Button5") == 0) return 0xfeed;
        if (strcmp(suffix, "DblClick_Dflt") == 0) return 0xfeee;
        if (strcmp(suffix, "DblClick1") == 0) return 0xfeef;
        if (strcmp(suffix, "DblClick2") == 0) return 0xfef0;
        if (strcmp(suffix, "DblClick3") == 0) return 0xfef1;
        if (strcmp(suffix, "DblClick4") == 0) return 0xfef2;
        if (strcmp(suffix, "DblClick5") == 0) return 0xfef3;
        if (strcmp(suffix, "Drag_Dflt") == 0) return 0xfef4;
        if (strcmp(suffix, "Drag1") == 0) return 0xfef5;
        if (strcmp(suffix, "Drag2") == 0) return 0xfef6;
        if (strcmp(suffix, "Drag3") == 0) return 0xfef7;
        if (strcmp(suffix, "Drag4") == 0) return 0xfef8;
        if (strcmp(suffix, "EnableKeys") == 0) return 0xfef9;
        if (strcmp(suffix, "Accelerate") == 0) return 0xfefa;
        if (strcmp(suffix, "DfltBtnNext") == 0) return 0xfefb;
        if (strcmp(suffix, "DfltBtnPrev") == 0) return 0xfefc;
        if (strcmp(suffix, "Drag5") == 0) return 0xfefd;
    }
    if (strncmp(name, "KP_", 3) == 0) {
	const char *suffix = name + 3;
        if (strcmp(suffix, "Space") == 0) return 0xff80;
        if (strcmp(suffix, "Tab") == 0) return 0xff89;
        if (strcmp(suffix, "Enter") == 0) return 0xff8d;
        if (strcmp(suffix, "F1") == 0) return 0xff91;
        if (strcmp(suffix, "F2") == 0) return 0xff92;
        if (strcmp(suffix, "F3") == 0) return 0xff93;
        if (strcmp(suffix, "F4") == 0) return 0xff94;
        if (strcmp(suffix, "Home") == 0) return 0xff95;
        if (strcmp(suffix, "Left") == 0) return 0xff96;
        if (strcmp(suffix, "Up") == 0) return 0xff97;
        if (strcmp(suffix, "Right") == 0) return 0xff98;
        if (strcmp(suffix, "Down") == 0) return 0xff99;
        if (strcmp(suffix, "Page_Up") == 0) return 0xff9a;
        if (strcmp(suffix, "Page_Down") == 0) return 0xff9b;
        if (strcmp(suffix, "End") == 0) return 0xff9c;
        if (strcmp(suffix, "Begin") == 0) return 0xff9d;
        if (strcmp(suffix, "Insert") == 0) return 0xff9e;
        if (strcmp(suffix, "Delete") == 0) return 0xff9f;
        if (strcmp(suffix, "Multiply") == 0) return 0xffaa;
        if (strcmp(suffix, "Add") == 0) return 0xffab;
        if (strcmp(suffix, "Separator") == 0) return 0xffac;
        if (strcmp(suffix, "Subtract") == 0) return 0xffad;
        if (strcmp(suffix, "Decimal") == 0) return 0xffae;
        if (strcmp(suffix, "Divide") == 0) return 0xffaf;
        if (strcmp(suffix, "0") == 0) return 0xffb0;
        if (strcmp(suffix, "1") == 0) return 0xffb1;
        if (strcmp(suffix, "2") == 0) return 0xffb2;
        if (strcmp(suffix, "3") == 0) return 0xffb3;
        if (strcmp(suffix, "4") == 0) return 0xffb4;
        if (strcmp(suffix, "5") == 0) return 0xffb5;
        if (strcmp(suffix, "6") == 0) return 0xffb6;
        if (strcmp(suffix, "7") == 0) return 0xffb7;
        if (strcmp(suffix, "8") == 0) return 0xffb8;
        if (strcmp(suffix, "9") == 0) return 0xffb9;
        if (strcmp(suffix, "Equal") == 0) return 0xffbd;
    }
    if (strncmp(name, "braille_", 8) == 0) {
	const char *suffix = name + 8;
        if (strcmp(suffix, "dot_1") == 0) return 0xfff1;
        if (strcmp(suffix, "dot_2") == 0) return 0xfff2;
        if (strcmp(suffix, "dot_3") == 0) return 0xfff3;
        if (strcmp(suffix, "dot_4") == 0) return 0xfff4;
        if (strcmp(suffix, "dot_5") == 0) return 0xfff5;
        if (strcmp(suffix, "dot_6") == 0) return 0xfff6;
        if (strcmp(suffix, "dot_7") == 0) return 0xfff7;
        if (strcmp(suffix, "dot_8") == 0) return 0xfff8;
        if (strcmp(suffix, "dot_9") == 0) return 0xfff9;
        if (strcmp(suffix, "dot_10") == 0) return 0xfffa;
    }
    if (strcmp(name, "topleftsummation") == 0) return 0x8b1;
    if (strcmp(name, "botleftsummation") == 0) return 0x8b2;
    if (strcmp(name, "topvertsummationconnector") == 0) return 0x8b3;
    if (strcmp(name, "botvertsummationconnector") == 0) return 0x8b4;
    if (strcmp(name, "toprightsummation") == 0) return 0x8b5;
    if (strcmp(name, "botrightsummation") == 0) return 0x8b6;
    if (strcmp(name, "rightmiddlesummation") == 0) return 0x8b7;
    if (strcmp(name, "blank") == 0) return 0x9df;
    if (strcmp(name, "marker") == 0) return 0xabf;
    if (strcmp(name, "trademarkincircle") == 0) return 0xacb;
    if (strcmp(name, "hexagram") == 0) return 0xada;
    if (strcmp(name, "cursor") == 0) return 0xaff;
    if (strcmp(name, "Thai_maihanakat_maitho") == 0) return 0xdde;
    if (strcmp(name, "AccessX_Enable") == 0) return 0xfe70;
    if (strcmp(name, "AccessX_Feedback_Enable") == 0) return 0xfe71;
    if (strcmp(name, "RepeatKeys_Enable") == 0) return 0xfe72;
    if (strcmp(name, "SlowKeys_Enable") == 0) return 0xfe73;
    if (strcmp(name, "BounceKeys_Enable") == 0) return 0xfe74;
    if (strcmp(name, "StickyKeys_Enable") == 0) return 0xfe75;
    if (strcmp(name, "MouseKeys_Enable") == 0) return 0xfe76;
    if (strcmp(name, "MouseKeys_Accel_Enable") == 0) return 0xfe77;
    if (strcmp(name, "Overlay1_Enable") == 0) return 0xfe78;
    if (strcmp(name, "Overlay2_Enable") == 0) return 0xfe79;
    if (strcmp(name, "AudibleBell_Enable") == 0) return 0xfe7a;
    if (strcmp(name, "ch") == 0) return 0xfea0;
    if (strcmp(name, "Ch") == 0) return 0xfea1;
    if (strcmp(name, "CH") == 0) return 0xfea2;
    if (strcmp(name, "c_h") == 0) return 0xfea3;
    if (strcmp(name, "C_h") == 0) return 0xfea4;
    if (strcmp(name, "C_H") == 0) return 0xfea5;
    if (strcmp(name, "First_Virtual_Screen") == 0) return 0xfed0;
    if (strcmp(name, "Prev_Virtual_Screen") == 0) return 0xfed1;
    if (strcmp(name, "Next_Virtual_Screen") == 0) return 0xfed2;
    if (strcmp(name, "Last_Virtual_Screen") == 0) return 0xfed4;
    if (strcmp(name, "Terminate_Server") == 0) return 0xfed5;
    if (strcmp(name, "BackSpace") == 0) return 0xff08;
    if (strcmp(name, "Tab") == 0) return 0xff09;
    if (strcmp(name, "Linefeed") == 0) return 0xff0a;
    if (strcmp(name, "Clear") == 0) return 0xff0b;
    if (strcmp(name, "Return") == 0) return 0xff0d;
    if (strcmp(name, "Pause") == 0) return 0xff13;
    if (strcmp(name, "Scroll_Lock") == 0) return 0xff14;
    if (strcmp(name, "Sys_Req") == 0) return 0xff15;
    if (strcmp(name, "Escape") == 0) return 0xff1b;
    if (strcmp(name, "Multi_key") == 0) return 0xff20;
    if (strcmp(name, "Kanji") == 0) return 0xff21;
    if (strcmp(name, "Muhenkan") == 0) return 0xff22;
    if (strcmp(name, "Henkan_Mode") == 0) return 0xff23;
    if (strcmp(name, "Romaji") == 0) return 0xff24;
    if (strcmp(name, "Hiragana") == 0) return 0xff25;
    if (strcmp(name, "Katakana") == 0) return 0xff26;
    if (strcmp(name, "Hiragana_Katakana") == 0) return 0xff27;
    if (strcmp(name, "Zenkaku") == 0) return 0xff28;
    if (strcmp(name, "Hankaku") == 0) return 0xff29;
    if (strcmp(name, "Zenkaku_Hankaku") == 0) return 0xff2a;
    if (strcmp(name, "Touroku") == 0) return 0xff2b;
    if (strcmp(name, "Massyo") == 0) return 0xff2c;
    if (strcmp(name, "Kana_Lock") == 0) return 0xff2d;
    if (strcmp(name, "Kana_Shift") == 0) return 0xff2e;
    if (strcmp(name, "Eisu_Shift") == 0) return 0xff2f;
    if (strcmp(name, "Eisu_toggle") == 0) return 0xff30;
    if (strcmp(name, "Hangul") == 0) return 0xff31;
    if (strcmp(name, "Codeinput") == 0) return 0xff37;
    if (strcmp(name, "SingleCandidate") == 0) return 0xff3c;
    if (strcmp(name, "MultipleCandidate") == 0) return 0xff3d;
    if (strcmp(name, "PreviousCandidate") == 0) return 0xff3e;
    if (strcmp(name, "Home") == 0) return 0xff50;
    if (strcmp(name, "Left") == 0) return 0xff51;
    if (strcmp(name, "Up") == 0) return 0xff52;
    if (strcmp(name, "Right") == 0) return 0xff53;
    if (strcmp(name, "Down") == 0) return 0xff54;
    if (strcmp(name, "Page_Up") == 0) return 0xff55;
    if (strcmp(name, "Page_Down") == 0) return 0xff56;
    if (strcmp(name, "End") == 0) return 0xff57;
    if (strcmp(name, "Begin") == 0) return 0xff58;
    if (strcmp(name, "Select") == 0) return 0xff60;
    if (strcmp(name, "Print") == 0) return 0xff61;
    if (strcmp(name, "Execute") == 0) return 0xff62;
    if (strcmp(name, "Insert") == 0) return 0xff63;
    if (strcmp(name, "Undo") == 0) return 0xff65;
    if (strcmp(name, "Redo") == 0) return 0xff66;
    if (strcmp(name, "Menu") == 0) return 0xff67;
    if (strcmp(name, "Find") == 0) return 0xff68;
    if (strcmp(name, "Cancel") == 0) return 0xff69;
    if (strcmp(name, "Help") == 0) return 0xff6a;
    if (strcmp(name, "Break") == 0) return 0xff6b;
    if (strcmp(name, "Mode_switch") == 0) return 0xff7e;
    if (strcmp(name, "Num_Lock") == 0) return 0xff7f;
    if (strcmp(name, "F1") == 0) return 0xffbe;
    if (strcmp(name, "F2") == 0) return 0xffbf;
    if (strcmp(name, "F3") == 0) return 0xffc0;
    if (strcmp(name, "F4") == 0) return 0xffc1;
    if (strcmp(name, "F5") == 0) return 0xffc2;
    if (strcmp(name, "F6") == 0) return 0xffc3;
    if (strcmp(name, "F7") == 0) return 0xffc4;
    if (strcmp(name, "F8") == 0) return 0xffc5;
    if (strcmp(name, "F9") == 0) return 0xffc6;
    if (strcmp(name, "F10") == 0) return 0xffc7;
    if (strcmp(name, "F11") == 0) return 0xffc8;
    if (strcmp(name, "F12") == 0) return 0xffc9;
    if (strcmp(name, "F13") == 0) return 0xffca;
    if (strcmp(name, "F14") == 0) return 0xffcb;
    if (strcmp(name, "F15") == 0) return 0xffcc;
    if (strcmp(name, "F16") == 0) return 0xffcd;
    if (strcmp(name, "F17") == 0) return 0xffce;
    if (strcmp(name, "F18") == 0) return 0xffcf;
    if (strcmp(name, "F19") == 0) return 0xffd0;
    if (strcmp(name, "F20") == 0) return 0xffd1;
    if (strcmp(name, "F21") == 0) return 0xffd2;
    if (strcmp(name, "F22") == 0) return 0xffd3;
    if (strcmp(name, "F23") == 0) return 0xffd4;
    if (strcmp(name, "F24") == 0) return 0xffd5;
    if (strcmp(name, "F25") == 0) return 0xffd6;
    if (strcmp(name, "F26") == 0) return 0xffd7;
    if (strcmp(name, "F27") == 0) return 0xffd8;
    if (strcmp(name, "F28") == 0) return 0xffd9;
    if (strcmp(name, "F29") == 0) return 0xffda;
    if (strcmp(name, "F30") == 0) return 0xffdb;
    if (strcmp(name, "F31") == 0) return 0xffdc;
    if (strcmp(name, "F32") == 0) return 0xffdd;
    if (strcmp(name, "F33") == 0) return 0xffde;
    if (strcmp(name, "F34") == 0) return 0xffdf;
    if (strcmp(name, "F35") == 0) return 0xffe0;
    if (strcmp(name, "Shift_L") == 0) return 0xffe1;
    if (strcmp(name, "Shift_R") == 0) return 0xffe2;
    if (strcmp(name, "Control_L") == 0) return 0xffe3;
    if (strcmp(name, "Control_R") == 0) return 0xffe4;
    if (strcmp(name, "Caps_Lock") == 0) return 0xffe5;
    if (strcmp(name, "Shift_Lock") == 0) return 0xffe6;
    if (strcmp(name, "Meta_L") == 0) return 0xffe7;
    if (strcmp(name, "Meta_R") == 0) return 0xffe8;
    if (strcmp(name, "Alt_L") == 0) return 0xffe9;
    if (strcmp(name, "Alt_R") == 0) return 0xffea;
    if (strcmp(name, "Super_L") == 0) return 0xffeb;
    if (strcmp(name, "Super_R") == 0) return 0xffec;
    if (strcmp(name, "Hyper_L") == 0) return 0xffed;
    if (strcmp(name, "Hyper_R") == 0) return 0xffee;
    if (strcmp(name, "Delete") == 0) return 0xffff;
    if (strcmp(name, "VoidSymbol") == 0) return 0xffffff;
    return 0;
}

const char *reverse_lookup_nonglyph_keysym(KeySym keysym)
{
    switch (keysym) {
    case 0x8b1: return "topleftsummation";
    case 0x8b2: return "botleftsummation";
    case 0x8b3: return "topvertsummationconnector";
    case 0x8b4: return "botvertsummationconnector";
    case 0x8b5: return "toprightsummation";
    case 0x8b6: return "botrightsummation";
    case 0x8b7: return "rightmiddlesummation";
    case 0x9df: return "blank";
    case 0xabf: return "marker";
    case 0xacb: return "trademarkincircle";
    case 0xada: return "hexagram";
    case 0xaff: return "cursor";
    case 0xdde: return "Thai_maihanakat_maitho";
    case 0xea1: return "Hangul_Kiyeog";
    case 0xea2: return "Hangul_SsangKiyeog";
    case 0xea3: return "Hangul_KiyeogSios";
    case 0xea4: return "Hangul_Nieun";
    case 0xea5: return "Hangul_NieunJieuj";
    case 0xea6: return "Hangul_NieunHieuh";
    case 0xea7: return "Hangul_Dikeud";
    case 0xea8: return "Hangul_SsangDikeud";
    case 0xea9: return "Hangul_Rieul";
    case 0xeaa: return "Hangul_RieulKiyeog";
    case 0xeab: return "Hangul_RieulMieum";
    case 0xeac: return "Hangul_RieulPieub";
    case 0xead: return "Hangul_RieulSios";
    case 0xeae: return "Hangul_RieulTieut";
    case 0xeaf: return "Hangul_RieulPhieuf";
    case 0xeb0: return "Hangul_RieulHieuh";
    case 0xeb1: return "Hangul_Mieum";
    case 0xeb2: return "Hangul_Pieub";
    case 0xeb3: return "Hangul_SsangPieub";
    case 0xeb4: return "Hangul_PieubSios";
    case 0xeb5: return "Hangul_Sios";
    case 0xeb6: return "Hangul_SsangSios";
    case 0xeb7: return "Hangul_Ieung";
    case 0xeb8: return "Hangul_Jieuj";
    case 0xeb9: return "Hangul_SsangJieuj";
    case 0xeba: return "Hangul_Cieuc";
    case 0xebb: return "Hangul_Khieuq";
    case 0xebc: return "Hangul_Tieut";
    case 0xebd: return "Hangul_Phieuf";
    case 0xebe: return "Hangul_Hieuh";
    case 0xebf: return "Hangul_A";
    case 0xec0: return "Hangul_AE";
    case 0xec1: return "Hangul_YA";
    case 0xec2: return "Hangul_YAE";
    case 0xec3: return "Hangul_EO";
    case 0xec4: return "Hangul_E";
    case 0xec5: return "Hangul_YEO";
    case 0xec6: return "Hangul_YE";
    case 0xec7: return "Hangul_O";
    case 0xec8: return "Hangul_WA";
    case 0xec9: return "Hangul_WAE";
    case 0xeca: return "Hangul_OE";
    case 0xecb: return "Hangul_YO";
    case 0xecc: return "Hangul_U";
    case 0xecd: return "Hangul_WEO";
    case 0xece: return "Hangul_WE";
    case 0xecf: return "Hangul_WI";
    case 0xed0: return "Hangul_YU";
    case 0xed1: return "Hangul_EU";
    case 0xed2: return "Hangul_YI";
    case 0xed3: return "Hangul_I";
    case 0xed4: return "Hangul_J_Kiyeog";
    case 0xed5: return "Hangul_J_SsangKiyeog";
    case 0xed6: return "Hangul_J_KiyeogSios";
    case 0xed7: return "Hangul_J_Nieun";
    case 0xed8: return "Hangul_J_NieunJieuj";
    case 0xed9: return "Hangul_J_NieunHieuh";
    case 0xeda: return "Hangul_J_Dikeud";
    case 0xedb: return "Hangul_J_Rieul";
    case 0xedc: return "Hangul_J_RieulKiyeog";
    case 0xedd: return "Hangul_J_RieulMieum";
    case 0xede: return "Hangul_J_RieulPieub";
    case 0xedf: return "Hangul_J_RieulSios";
    case 0xee0: return "Hangul_J_RieulTieut";
    case 0xee1: return "Hangul_J_RieulPhieuf";
    case 0xee2: return "Hangul_J_RieulHieuh";
    case 0xee3: return "Hangul_J_Mieum";
    case 0xee4: return "Hangul_J_Pieub";
    case 0xee5: return "Hangul_J_PieubSios";
    case 0xee6: return "Hangul_J_Sios";
    case 0xee7: return "Hangul_J_SsangSios";
    case 0xee8: return "Hangul_J_Ieung";
    case 0xee9: return "Hangul_J_Jieuj";
    case 0xeea: return "Hangul_J_Cieuc";
    case 0xeeb: return "Hangul_J_Khieuq";
    case 0xeec: return "Hangul_J_Tieut";
    case 0xeed: return "Hangul_J_Phieuf";
    case 0xeee: return "Hangul_J_Hieuh";
    case 0xeef: return "Hangul_RieulYeorinHieuh";
    case 0xef0: return "Hangul_SunkyeongeumMieum";
    case 0xef1: return "Hangul_SunkyeongeumPieub";
    case 0xef2: return "Hangul_PanSios";
    case 0xef3: return "Hangul_KkogjiDalrinIeung";
    case 0xef4: return "Hangul_SunkyeongeumPhieuf";
    case 0xef5: return "Hangul_YeorinHieuh";
    case 0xef6: return "Hangul_AraeA";
    case 0xef7: return "Hangul_AraeAE";
    case 0xef8: return "Hangul_J_PanSios";
    case 0xef9: return "Hangul_J_KkogjiDalrinIeung";
    case 0xefa: return "Hangul_J_YeorinHieuh";
    case 0xfd01: return "3270_Duplicate";
    case 0xfd02: return "3270_FieldMark";
    case 0xfd03: return "3270_Right2";
    case 0xfd04: return "3270_Left2";
    case 0xfd05: return "3270_BackTab";
    case 0xfd06: return "3270_EraseEOF";
    case 0xfd07: return "3270_EraseInput";
    case 0xfd08: return "3270_Reset";
    case 0xfd09: return "3270_Quit";
    case 0xfd0a: return "3270_PA1";
    case 0xfd0b: return "3270_PA2";
    case 0xfd0c: return "3270_PA3";
    case 0xfd0d: return "3270_Test";
    case 0xfd0e: return "3270_Attn";
    case 0xfd0f: return "3270_CursorBlink";
    case 0xfd10: return "3270_AltCursor";
    case 0xfd11: return "3270_KeyClick";
    case 0xfd12: return "3270_Jump";
    case 0xfd13: return "3270_Ident";
    case 0xfd14: return "3270_Rule";
    case 0xfd15: return "3270_Copy";
    case 0xfd16: return "3270_Play";
    case 0xfd17: return "3270_Setup";
    case 0xfd18: return "3270_Record";
    case 0xfd19: return "3270_ChangeScreen";
    case 0xfd1a: return "3270_DeleteWord";
    case 0xfd1b: return "3270_ExSelect";
    case 0xfd1c: return "3270_CursorSelect";
    case 0xfd1d: return "3270_PrintScreen";
    case 0xfd1e: return "3270_Enter";
    case 0xfe01: return "ISO_Lock";
    case 0xfe02: return "ISO_Level2_Latch";
    case 0xfe03: return "ISO_Level3_Shift";
    case 0xfe04: return "ISO_Level3_Latch";
    case 0xfe05: return "ISO_Level3_Lock";
    case 0xfe06: return "ISO_Group_Latch";
    case 0xfe07: return "ISO_Group_Lock";
    case 0xfe08: return "ISO_Next_Group";
    case 0xfe09: return "ISO_Next_Group_Lock";
    case 0xfe0a: return "ISO_Prev_Group";
    case 0xfe0b: return "ISO_Prev_Group_Lock";
    case 0xfe0c: return "ISO_First_Group";
    case 0xfe0d: return "ISO_First_Group_Lock";
    case 0xfe0e: return "ISO_Last_Group";
    case 0xfe0f: return "ISO_Last_Group_Lock";
    case 0xfe11: return "ISO_Level5_Shift";
    case 0xfe12: return "ISO_Level5_Latch";
    case 0xfe13: return "ISO_Level5_Lock";
    case 0xfe20: return "ISO_Left_Tab";
    case 0xfe21: return "ISO_Move_Line_Up";
    case 0xfe22: return "ISO_Move_Line_Down";
    case 0xfe23: return "ISO_Partial_Line_Up";
    case 0xfe24: return "ISO_Partial_Line_Down";
    case 0xfe25: return "ISO_Partial_Space_Left";
    case 0xfe26: return "ISO_Partial_Space_Right";
    case 0xfe27: return "ISO_Set_Margin_Left";
    case 0xfe28: return "ISO_Set_Margin_Right";
    case 0xfe29: return "ISO_Release_Margin_Left";
    case 0xfe2a: return "ISO_Release_Margin_Right";
    case 0xfe2b: return "ISO_Release_Both_Margins";
    case 0xfe2c: return "ISO_Fast_Cursor_Left";
    case 0xfe2d: return "ISO_Fast_Cursor_Right";
    case 0xfe2e: return "ISO_Fast_Cursor_Up";
    case 0xfe2f: return "ISO_Fast_Cursor_Down";
    case 0xfe30: return "ISO_Continuous_Underline";
    case 0xfe31: return "ISO_Discontinuous_Underline";
    case 0xfe32: return "ISO_Emphasize";
    case 0xfe33: return "ISO_Center_Object";
    case 0xfe34: return "ISO_Enter";
    case 0xfe50: return "dead_grave";
    case 0xfe51: return "dead_acute";
    case 0xfe52: return "dead_circumflex";
    case 0xfe53: return "dead_tilde";
    case 0xfe54: return "dead_macron";
    case 0xfe55: return "dead_breve";
    case 0xfe56: return "dead_abovedot";
    case 0xfe57: return "dead_diaeresis";
    case 0xfe58: return "dead_abovering";
    case 0xfe59: return "dead_doubleacute";
    case 0xfe5a: return "dead_caron";
    case 0xfe5b: return "dead_cedilla";
    case 0xfe5c: return "dead_ogonek";
    case 0xfe5d: return "dead_iota";
    case 0xfe5e: return "dead_voiced_sound";
    case 0xfe5f: return "dead_semivoiced_sound";
    case 0xfe60: return "dead_belowdot";
    case 0xfe61: return "dead_hook";
    case 0xfe62: return "dead_horn";
    case 0xfe63: return "dead_stroke";
    case 0xfe64: return "dead_abovecomma";
    case 0xfe65: return "dead_abovereversedcomma";
    case 0xfe66: return "dead_doublegrave";
    case 0xfe67: return "dead_belowring";
    case 0xfe68: return "dead_belowmacron";
    case 0xfe69: return "dead_belowcircumflex";
    case 0xfe6a: return "dead_belowtilde";
    case 0xfe6b: return "dead_belowbreve";
    case 0xfe6c: return "dead_belowdiaeresis";
    case 0xfe6d: return "dead_invertedbreve";
    case 0xfe6e: return "dead_belowcomma";
    case 0xfe6f: return "dead_currency";
    case 0xfe70: return "AccessX_Enable";
    case 0xfe71: return "AccessX_Feedback_Enable";
    case 0xfe72: return "RepeatKeys_Enable";
    case 0xfe73: return "SlowKeys_Enable";
    case 0xfe74: return "BounceKeys_Enable";
    case 0xfe75: return "StickyKeys_Enable";
    case 0xfe76: return "MouseKeys_Enable";
    case 0xfe77: return "MouseKeys_Accel_Enable";
    case 0xfe78: return "Overlay1_Enable";
    case 0xfe79: return "Overlay2_Enable";
    case 0xfe7a: return "AudibleBell_Enable";
    case 0xfe80: return "dead_a";
    case 0xfe81: return "dead_A";
    case 0xfe82: return "dead_e";
    case 0xfe83: return "dead_E";
    case 0xfe84: return "dead_i";
    case 0xfe85: return "dead_I";
    case 0xfe86: return "dead_o";
    case 0xfe87: return "dead_O";
    case 0xfe88: return "dead_u";
    case 0xfe89: return "dead_U";
    case 0xfe8a: return "dead_small_schwa";
    case 0xfe8b: return "dead_capital_schwa";
    case 0xfe8c: return "dead_greek";
    case 0xfea0: return "ch";
    case 0xfea1: return "Ch";
    case 0xfea2: return "CH";
    case 0xfea3: return "c_h";
    case 0xfea4: return "C_h";
    case 0xfea5: return "C_H";
    case 0xfed0: return "First_Virtual_Screen";
    case 0xfed1: return "Prev_Virtual_Screen";
    case 0xfed2: return "Next_Virtual_Screen";
    case 0xfed4: return "Last_Virtual_Screen";
    case 0xfed5: return "Terminate_Server";
    case 0xfee0: return "Pointer_Left";
    case 0xfee1: return "Pointer_Right";
    case 0xfee2: return "Pointer_Up";
    case 0xfee3: return "Pointer_Down";
    case 0xfee4: return "Pointer_UpLeft";
    case 0xfee5: return "Pointer_UpRight";
    case 0xfee6: return "Pointer_DownLeft";
    case 0xfee7: return "Pointer_DownRight";
    case 0xfee8: return "Pointer_Button_Dflt";
    case 0xfee9: return "Pointer_Button1";
    case 0xfeea: return "Pointer_Button2";
    case 0xfeeb: return "Pointer_Button3";
    case 0xfeec: return "Pointer_Button4";
    case 0xfeed: return "Pointer_Button5";
    case 0xfeee: return "Pointer_DblClick_Dflt";
    case 0xfeef: return "Pointer_DblClick1";
    case 0xfef0: return "Pointer_DblClick2";
    case 0xfef1: return "Pointer_DblClick3";
    case 0xfef2: return "Pointer_DblClick4";
    case 0xfef3: return "Pointer_DblClick5";
    case 0xfef4: return "Pointer_Drag_Dflt";
    case 0xfef5: return "Pointer_Drag1";
    case 0xfef6: return "Pointer_Drag2";
    case 0xfef7: return "Pointer_Drag3";
    case 0xfef8: return "Pointer_Drag4";
    case 0xfef9: return "Pointer_EnableKeys";
    case 0xfefa: return "Pointer_Accelerate";
    case 0xfefb: return "Pointer_DfltBtnNext";
    case 0xfefc: return "Pointer_DfltBtnPrev";
    case 0xfefd: return "Pointer_Drag5";
    case 0xff08: return "BackSpace";
    case 0xff09: return "Tab";
    case 0xff0a: return "Linefeed";
    case 0xff0b: return "Clear";
    case 0xff0d: return "Return";
    case 0xff13: return "Pause";
    case 0xff14: return "Scroll_Lock";
    case 0xff15: return "Sys_Req";
    case 0xff1b: return "Escape";
    case 0xff20: return "Multi_key";
    case 0xff21: return "Kanji";
    case 0xff22: return "Muhenkan";
    case 0xff23: return "Henkan_Mode";
    case 0xff24: return "Romaji";
    case 0xff25: return "Hiragana";
    case 0xff26: return "Katakana";
    case 0xff27: return "Hiragana_Katakana";
    case 0xff28: return "Zenkaku";
    case 0xff29: return "Hankaku";
    case 0xff2a: return "Zenkaku_Hankaku";
    case 0xff2b: return "Touroku";
    case 0xff2c: return "Massyo";
    case 0xff2d: return "Kana_Lock";
    case 0xff2e: return "Kana_Shift";
    case 0xff2f: return "Eisu_Shift";
    case 0xff30: return "Eisu_toggle";
    case 0xff31: return "Hangul";
    case 0xff32: return "Hangul_Start";
    case 0xff33: return "Hangul_End";
    case 0xff34: return "Hangul_Hanja";
    case 0xff35: return "Hangul_Jamo";
    case 0xff36: return "Hangul_Romaja";
    case 0xff37: return "Codeinput";
    case 0xff38: return "Hangul_Jeonja";
    case 0xff39: return "Hangul_Banja";
    case 0xff3a: return "Hangul_PreHanja";
    case 0xff3b: return "Hangul_PostHanja";
    case 0xff3c: return "SingleCandidate";
    case 0xff3d: return "MultipleCandidate";
    case 0xff3e: return "PreviousCandidate";
    case 0xff3f: return "Hangul_Special";
    case 0xff50: return "Home";
    case 0xff51: return "Left";
    case 0xff52: return "Up";
    case 0xff53: return "Right";
    case 0xff54: return "Down";
    case 0xff55: return "Page_Up";
    case 0xff56: return "Page_Down";
    case 0xff57: return "End";
    case 0xff58: return "Begin";
    case 0xff60: return "Select";
    case 0xff61: return "Print";
    case 0xff62: return "Execute";
    case 0xff63: return "Insert";
    case 0xff65: return "Undo";
    case 0xff66: return "Redo";
    case 0xff67: return "Menu";
    case 0xff68: return "Find";
    case 0xff69: return "Cancel";
    case 0xff6a: return "Help";
    case 0xff6b: return "Break";
    case 0xff7e: return "Mode_switch";
    case 0xff7f: return "Num_Lock";
    case 0xff80: return "KP_Space";
    case 0xff89: return "KP_Tab";
    case 0xff8d: return "KP_Enter";
    case 0xff91: return "KP_F1";
    case 0xff92: return "KP_F2";
    case 0xff93: return "KP_F3";
    case 0xff94: return "KP_F4";
    case 0xff95: return "KP_Home";
    case 0xff96: return "KP_Left";
    case 0xff97: return "KP_Up";
    case 0xff98: return "KP_Right";
    case 0xff99: return "KP_Down";
    case 0xff9a: return "KP_Page_Up";
    case 0xff9b: return "KP_Page_Down";
    case 0xff9c: return "KP_End";
    case 0xff9d: return "KP_Begin";
    case 0xff9e: return "KP_Insert";
    case 0xff9f: return "KP_Delete";
    case 0xffaa: return "KP_Multiply";
    case 0xffab: return "KP_Add";
    case 0xffac: return "KP_Separator";
    case 0xffad: return "KP_Subtract";
    case 0xffae: return "KP_Decimal";
    case 0xffaf: return "KP_Divide";
    case 0xffb0: return "KP_0";
    case 0xffb1: return "KP_1";
    case 0xffb2: return "KP_2";
    case 0xffb3: return "KP_3";
    case 0xffb4: return "KP_4";
    case 0xffb5: return "KP_5";
    case 0xffb6: return "KP_6";
    case 0xffb7: return "KP_7";
    case 0xffb8: return "KP_8";
    case 0xffb9: return "KP_9";
    case 0xffbd: return "KP_Equal";
    case 0xffbe: return "F1";
    case 0xffbf: return "F2";
    case 0xffc0: return "F3";
    case 0xffc1: return "F4";
    case 0xffc2: return "F5";
    case 0xffc3: return "F6";
    case 0xffc4: return "F7";
    case 0xffc5: return "F8";
    case 0xffc6: return "F9";
    case 0xffc7: return "F10";
    case 0xffc8: return "F11";
    case 0xffc9: return "F12";
    case 0xffca: return "F13";
    case 0xffcb: return "F14";
    case 0xffcc: return "F15";
    case 0xffcd: return "F16";
    case 0xffce: return "F17";
    case 0xffcf: return "F18";
    case 0xffd0: return "F19";
    case 0xffd1: return "F20";
    case 0xffd2: return "F21";
    case 0xffd3: return "F22";
    case 0xffd4: return "F23";
    case 0xffd5: return "F24";
    case 0xffd6: return "F25";
    case 0xffd7: return "F26";
    case 0xffd8: return "F27";
    case 0xffd9: return "F28";
    case 0xffda: return "F29";
    case 0xffdb: return "F30";
    case 0xffdc: return "F31";
    case 0xffdd: return "F32";
    case 0xffde: return "F33";
    case 0xffdf: return "F34";
    case 0xffe0: return "F35";
    case 0xffe1: return "Shift_L";
    case 0xffe2: return "Shift_R";
    case 0xffe3: return "Control_L";
    case 0xffe4: return "Control_R";
    case 0xffe5: return "Caps_Lock";
    case 0xffe6: return "Shift_Lock";
    case 0xffe7: return "Meta_L";
    case 0xffe8: return "Meta_R";
    case 0xffe9: return "Alt_L";
    case 0xffea: return "Alt_R";
    case 0xffeb: return "Super_L";
    case 0xffec: return "Super_R";
    case 0xffed: return "Hyper_L";
    case 0xffee: return "Hyper_R";
    case 0xfff1: return "braille_dot_1";
    case 0xfff2: return "braille_dot_2";
    case 0xfff3: return "braille_dot_3";
    case 0xfff4: return "braille_dot_4";
    case 0xfff5: return "braille_dot_5";
    case 0xfff6: return "braille_dot_6";
    case 0xfff7: return "braille_dot_7";
    case 0xfff8: return "braille_dot_8";
    case 0xfff9: return "braille_dot_9";
    case 0xfffa: return "braille_dot_10";
    case 0xffff: return "Delete";
    case 0xffffff: return "VoidSymbol";
    default:
	return NULL;
    }
}
