/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_TABBAR_H
#define TOOLKIT_TABBAR_H

#include "widget.h"

class ItemInterior;
class Item;
class Shadow;

namespace Toolkit {

class TabBarShadow;
class Menu;

class TabBar : public Widget
{
    ItemInterior *_interior;
    TabBarShadow *main_shadow;
    Item *selected_tab;
    virtual void tabSelected() = 0;
    virtual Menu *invokeContextMenu(Shadow *shadow) = 0;
public:
    TabBar(Connection &conn);
    ~TabBar();
    ItemInterior *interior() const;
    void setInterior(ItemInterior *interior);
    Item *selectedTab() const;
    void selectTab(Item *tab);
    unsigned int selectedTabIndex() const;

    void paint(const Region &region, X::Pixmap pixmap);
    void buttonPressEvent(Time time, int x, int y,
			  int x_root, int y_root,
			  unsigned int state, unsigned int button);
};

} /* namespace Toolkit */

#endif
