/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_VIEWS_DIRECTORYVIEW_H
#define TOOLKIT_VIEWS_DIRECTORYVIEW_H

#include "view.h"

namespace Toolkit {

class DirectoryView : public View, Focussable
{
    virtual void setSelected(ViewShadow *selected, bool toggle) = 0;
    virtual bool isSelected(ViewShadow *shadow) const = 0;
public:
    DirectoryView(Connection &conn);
    void buttonPressEvent(Time time, int x, int y,
			  int x_root, int y_root,
			  unsigned int state, unsigned int button);

    ViewShadowLayout layoutShadow(ViewShadow *shadow);
    void paintShadow(ViewShadow *shadow,
		     int origin_x, int origin_y, X::Pixmap pixmap);
};

} /* namespace Toolkit */

#endif
